package applications.basics;

/** 
    CalendarField is a CalendarField based on JCalendard from Kai Toedter
    The latest version of CalendarBean you find at www.geocities.com/SiliconValley/2123/calendarbean 
    it extends this to a setText and a getText-Method to integrate it into Admin-functions.


    Admin is a Tool around mySQL to do basic jobs
    for DB-Administrations, like:
    - create/ drop tables
    - create  indices
    - perform sql-statements
    - simple form
    - a guided query
    and a other usefull things in DB-arena

    Admin V1.2 
    Copyright (c) 1999 Fredy Fischer
                       se-afs@dial.eunet.ch

		       Fredy Fischer
		       Hulmenweg 36
		       8405 Winterthur
		       Switzerland

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**/


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import CalendarBean.*;
import java.util.*;
import java.text.*;

public class CalendarField extends JButton {

    private JFrame    frame;
    public  JCalendar jcal;
 
    /** 
	this is to set the date in the form yyyy-mm-dd
    **/
    Calendar cal;

    public void setDate(String v) {


     StringTokenizer st = new StringTokenizer(v,"-");
     String y = st.nextToken();
     String m = st.nextToken();
     String d = st.nextToken();

     cal.set(Integer.parseInt(y),Integer.parseInt(m)-1,Integer.parseInt(d));
     this.setText(v);
     jcal.setCalendar(cal);
    }


    public String getDate() {

	Calendar cal1 = jcal.getCalendar();
	String y = Integer.toString(cal1.get(cal1.YEAR));
	String m = Integer.toString(cal1.get(cal1.MONTH)+1);
	m = trailing(m);
	String d = Integer.toString(cal1.get(cal1.DAY_OF_MONTH));
	d = trailing(d);

	this.setText( y + "-" + m + "-" + d);
	return y + "-" + m + "-" + d;

    }


    private String trailing(String v) {
	if (v.length() < 2 ) v = "0"+ v;
	return v;
    }

    private JPanel buttonPanel() {
	JPanel panel = new JPanel();
	panel.setLayout(new FlowLayout());

	JButton select = new JButton("Select");
	select.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		getDate();
		frame.dispose();
		}});
	JButton cancel = new JButton("Cancel");
	cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		frame.dispose();
		}});
	
	panel.add(select);
	panel.add(cancel);

	return panel;
    }

    private String toDay() {
	String y = Integer.toString(cal.get(cal.YEAR));
	String m = Integer.toString(cal.get(cal.MONTH)+1);
	m = trailing(m);
	String d = Integer.toString(cal.get(cal.DAY_OF_MONTH));
	d = trailing(d);
	
	return y + "-" + d + "-" + m;

    }

    public CalendarField(String v) {

     cal = Calendar.getInstance();
     this.setText(toDay());

     frame = new JFrame("Date of " + v);
     frame.addWindowListener(new WindowAdapter() {
	 public void windowActivated(WindowEvent e) {}
	 public void windowClosed(WindowEvent e) {}
	 public void windowClosing(WindowEvent e) {frame.dispose();}
	 public void windowDeactivated(WindowEvent e) {}
	 public void windowDeiconified(WindowEvent e) {}
	 public void windowIconified(WindowEvent e) {}
	 public void windowOpened(WindowEvent e) {}});
     
     jcal = new JCalendar();

     frame.getContentPane().setLayout(new BorderLayout());
     frame.getContentPane().add("Center",jcal);
     frame.getContentPane().add("South",buttonPanel());

     frame.pack();
     this.addActionListener(new ActionListener() {
	 public void actionPerformed(ActionEvent e) {
	     	frame.setVisible(true);
	     }});
     


    }


    public static void main(String args[]) {

	JFrame f = new JFrame();
	f.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeactivated(WindowEvent e) {}
	    public void windowDeiconified(WindowEvent e) {}
	    public void windowIconified(WindowEvent e) {}
	    public void windowOpened(WindowEvent e) {}});
	CalendarField cf = new CalendarField(args[0]);
	f.getContentPane().add(cf);
	f.pack();
	f.setVisible(true);
    }
}
