package applications.basics;

/** 
     F1table is a extension to Admin that allows to feed the result
     of a SQL-Query into F1Java


    Admin is a Tool around mySQL to do basic jobs
    for DB-Administrations, like:
    - create/ drop tables
    - create  indices
    - perform sql-statements
    - simple form
    - a guided query
    and a other usefull things in DB-arena

    Admin V1.2 
    Copyright (c) 1999 Fredy Fischer
                       se-afs@dial.eunet.ch

		       Fredy Fischer
		       Hulmenweg 36
		       8405 Winterthur
		       Switzerland

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**/


import java.awt.*;
import java.awt.event.*;

import java.io.*;
import java.util.*;
import java.net.*;
import java.sql.*;
import applications.basics.t_connect;
import com.f1j.*;

public class F1table extends Frame {


    private ResultSet sqlresult;
    private ResultSetMetaData metaData;
    private t_connect con;
    public Button cancel, launchJDBC;
    public View view1;
    private JDBC jdbc;
    private JDBCQueryObj queryObj;
    private JDBCQueryObj qObj;

    private String dbgMessage = "";
    public String getMessage() { return dbgMessage;}

    String host;
    
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host.
       */
    public void setHost(String  v) {this.host = v;}
    
    /**
       * Get the value of l.
       * @return Value of l.
       */

    /**
       * Set the value of l.
       * @param v  Value to assign to l.
       */

    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    

    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}
    

    String database;
    
    /**
       * Get the value of database.
       * @return Value of database.
       */
    public String getDatabase() {return database;}
    
    /**
       * Set the value of database.
       * @param v  Value to assign to database.
       */
    public void setDatabase(String  v) {this.database = v;}


    String query;
    
    /**
       * Get the value of query.
       * @return Value of query.
       */
    public String getQuery() {return query;}
    
    /**
       * Set the value of query.
       * @param v  Value to assign to query.
       */
    public void setQuery(String  v) {this.query = v;}
    
    public F1table (String host, String user, String password, String database, String query) {

	

	setHost(host);
	setUser(user);
	setPassword(password);
	setDatabase(database);
	setQuery(query);

        con = new t_connect(getHost(), getUser(), getPassword(),getDatabase());  
	if (con.getError() != null) message("Connection Error: "+ con.getError());
	
	this.setLayout(new BorderLayout());

	view1 = new View(); 
        jdbc = new JDBC(view1);
	queryObj = new JDBCQueryObj(); 
       
	queryObj.setQueryStr(getQuery()); 
	queryObj.setAutoColNames(true); 
        queryObj.setAutoColFormats(true); 
        queryObj.setAutoColWidths(true); 
        queryObj.setAutoMaxRC(true); 
        queryObj.setStartRow(0); 
        queryObj.setStartCol(0); 
        queryObj.setColNamesInRow(-1); 

        try { 
           if (queryObj.getQueryStr() !=null) { 
           sqlresult = con.stmt.executeQuery(queryObj.getQueryStr()); 
           jdbc.populateGrid(sqlresult, queryObj); 
           sqlresult.close(); 
	   }
       }  catch (Exception e) {  
          message("1. Query-Error: " +e.getMessage().toString()); 
          //con.close();
       } 
       view1.setPrintColHeading(true);
       view1.setAllowEditHeaders(true);
       view1.setBackColor(Color.white);
       this.add("Center",view1);
       //view1.launchDesigner();
       this.add("South",buttonPanel());

       Dimension dim = new Dimension();
       dim = view1.getPreferredSize();
       dim.height = view1.getLastRow() * view1.getDefaultFontSize() / 20;
       dim.width  = view1.getLastCol() * view1.getDefaultColWidth() / 20;
       view1.setSize(dim);
 
       this.pack();

    }

    private void message(String msg) {
	   dbgMessage = dbgMessage + "\n" + msg;
	   //System.out.println(getQuery() + "   :" + msg + "\n");
    }

    private Panel buttonPanel() {

      Panel panel = new Panel();
      panel.setLayout(new FlowLayout());

      Button editor = new Button("Editor");
      editor.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	        view1.launchDesigner();
		}});
	cancel = new Button("Cancel");
	panel.add(editor);
	panel.add(cancel);

	Button launchJDBC = new Button("Database");
	launchJDBC.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		try {
		    qObj = jdbc.queryDlg(con.con, queryObj); 
		    
		    if (qObj.getQueryStr() !=null) { 
			sqlresult = con.stmt.executeQuery(qObj.getQueryStr()); 
			jdbc.populateGrid(sqlresult, queryObj); 
			sqlresult.close(); 
		    }
		} catch (Exception excp) {  
		    message("2. Query-Error: " + excp.getMessage().toString()); 
		    //con.close();
		}
	    }});
	panel.add(launchJDBC);

	return panel;
    }
      
    public static void main(String args[]) {

	System.out.println("Fredy's Formula-one-table\n" +
			   "------------------------- \nVersion 1.0\n");
                          
	if ( args.length != 5) {
	    System.out.println("Syntax: java applications.basics.F1table host user password database query");
	    System.exit(0);
	}
	F1table ft = new F1table(args[0],args[1],args[2],args[3],args[4]);

	ft.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	    public void windowDeactivated(WindowEvent e) {}
	    public void windowDeiconified(WindowEvent e) {}
	    public void windowIconified(WindowEvent e) {}
	    public void windowOpened(WindowEvent e) {}});

	ft.cancel.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	ft.pack();
	ft.setVisible(true);
    }
}
