package applications.basics;

/** 
    SQL-Monitor is a part of Admin ...

    Admin is a Tool around mySQL to do basic jobs
    for DB-Administrations, like:
    - create/ drop tables
    - create  indices
    - perform sql-statements
    - simple form
    - a guided query
    and a other usefull things in DB-arena

    Admin V1.1.1
    Copyright (c) 1999 Fredy Fischer
                       se-afs@dial.eunet.ch

		       Fredy Fischer
		       Hulmenweg 36
		       8405 Winterthur
		       Switzerland

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**/


import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JPanel; 
import javax.swing.JFrame;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;


public class SqlMonitor extends JPanel {

    private JTextArea query, response;
    private JSplitPane splitPane;
    public JPanel lowerPanel,upperPanel;
    public JScrollPane scp;
    public SqlPanel st;
    public Toolkit tk;
    public JButton exit;
    public JTable tableView;
    public JScrollPane scrollpane;
    public JMenuItem quit, setTitle;

    private Dimension tbDim;

    //private JDBCAdapter dt;
    String host;
    
    /**
       * Get the value of host.
       * @return Value of host.
       */
    public String getHost() {return host;}
    
    /**
       * Set the value of host.
       * @param v  Value to assign to host.
       */
    public void setHost(String  v) {this.host = v;}
    
    String user;
    
    /**
       * Get the value of user.
       * @return Value of user.
       */
    public String getUser() {return user;}
    
    /**
       * Set the value of user.
       * @param v  Value to assign to user.
       */
    public void setUser(String  v) {this.user = v;}
    
    String password;
    
    /**
       * Get the value of password.
       * @return Value of password.
       */
    public String getPassword() {return password;}
    
    /**
       * Set the value of password.
       * @param v  Value to assign to password.
       */
    public void setPassword(String  v) {this.password = v;}
    
    
    String database;
    
    /**
       * Get the value of database.
       * @return Value of database.
       */
    public String getDatabase() {return database;}
    
    /**
       * Set the value of database.
       * @param v  Value to assign to database.
       */
    public void setDatabase(String  v) {this.database = v;}
    

    
    private JMenuBar menubar() {

	JMenuBar mb = new JMenuBar();

	JMenu file = new JMenu("File");
	JMenu edit = new JMenu("Edit");
	
	JMenu properties = new JMenu("Properties");
	setTitle = new JMenuItem("Set title");
	properties.add(setTitle);


	JMenuItem exc = new JMenuItem("Exec Query",loadImage("binocular.gif"));
	exc.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		execQuery();
		}});	
	JMenuItem clear = new JMenuItem("Clear",loadImage("sheet.gif"));
	clear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		query.setText("");
		}});

	JMenuItem copy = new JMenuItem("Copy",loadImage("copy.gif"));
	copy.setToolTipText("Copy all to clipboard");
	copy.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String s = query.getText();
		StringSelection ss = new StringSelection(s);
		tk.getSystemClipboard().setContents(ss,ss);
		}});

	JMenuItem paste = new JMenuItem("Paste",loadImage("paste.gif"));
	paste.setToolTipText("Paste");
	paste.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		Clipboard c =tk.getSystemClipboard();
		Transferable t = c.getContents(this);
		try { 
		    String s = (String) t.getTransferData(DataFlavor.stringFlavor);
		    query.setText(s); 
		}
		catch (Exception eexc) { 
		    tk.beep();
		}
		}});

	JMenuItem export = new JMenuItem("Export",loadImage("export.gif"));
	export.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		 if ( query.getText().toLowerCase().startsWith("select") | query.getText().toLowerCase().startsWith("show") ) {
		     final ExportQuery eq = new ExportQuery(getHost(),getUser(),getPassword(),getDatabase());
		     eq.setQuery(query.getText());
		     eq.selectFile();
		     eq.cancel.addActionListener(new ActionListener() {
		       public void actionPerformed(ActionEvent e) {
			 eq.frame.dispose();
		       }});	  		     
		     eq.export();		     
		 }
		}});

	quit = new JMenuItem("Quit",loadImage("exit.gif"));


	file.add(exc);
	file.add(export);
	file.add(new JSeparator());
        file.add(properties);
	file.add(new JSeparator());
	file.add(quit);

	edit.add(copy);
	edit.add(paste);
	
	
	mb.add(file);
	mb.add(edit);

	return mb;



    }


    private JPanel toolbar() {

	JPanel tb = new JPanel();
	//tb.setOrientation(JToolBar.HORIZONTAL);

	tb.setBorder(new BevelBorder(BevelBorder.RAISED));

	JButton exec = new JButton(loadImage("binocular.gif"));
	exec.setToolTipText("Execute query");
	exec.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		execQuery();
		}});	
	tb.add(exec);


	JButton clear = new JButton(loadImage("sheet.gif"));
	clear.setToolTipText("Clear");
	clear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		query.setText("");
		}});
	tb.add(clear);
	
	JButton copy = new JButton(loadImage("copy.gif"));
	copy.setToolTipText("Copy all to clipboard");
	copy.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		String s = query.getText();
		StringSelection ss = new StringSelection(s);
		tk.getSystemClipboard().setContents(ss,ss);
		}});
	tb.add(copy);

	JButton paste = new JButton(loadImage("paste.gif"));
	paste.setToolTipText("Paste");
	paste.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		Clipboard c =tk.getSystemClipboard();
		Transferable t = c.getContents(this);
		try { 
		    String s = (String) t.getTransferData(DataFlavor.stringFlavor);
		    query.setText(s); 
		}
		catch (Exception eexc) { 
		    tk.beep();
		}
		}});
	tb.add(paste);


	JButton export = new JButton(loadImage("export.gif"));
	export.setToolTipText("Export result");
	export.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		 if ( query.getText().toLowerCase().startsWith("select") | query.getText().toLowerCase().startsWith("show") ) {
		     ExportQuery eq = new ExportQuery(getHost(),getUser(),getPassword(),getDatabase());
		     eq.setQuery(query.getText());
		     eq.selectFile();
		     eq.export();		     
		 }
		}});
	tb.add(export);


	
	exit = new JButton(loadImage("exit.gif"));
	exit.setToolTipText("Quit");
	tb.add(exit);


	tbDim = new Dimension();
	tbDim = tb.getSize();

	return tb;
    }


    private ImageIcon loadImage(String image) {
	String admin_img = System.getProperty("admin.image");
	ImageIcon img = null;
        try {
	  if (admin_img == null) {
	    img = new ImageIcon(SqlMonitor.class.getResource("images"+ File.separator + image));
	  } else {
	    img = new ImageIcon(admin_img + File.separator + image);
	  }
	} catch (Exception someException ) {
	  System.out.println("Exception while creating Image-Button with image: " + image + "\ntrying to load from : " + admin_img + "\n" + someException.getMessage()); 
	}    
        return img;
    }



    private JPanel queryPanel() {

        JPanel fp = new JPanel();

	query = new JTextArea(12,40);
	query.setFont(new Font("Monospaced", Font.PLAIN, 12));
	JScrollPane scrollPane = new JScrollPane(query);

	fp.add(scrollPane);
	DBTree dbt = new DBTree(getHost(), getUser(),getPassword(),getDatabase());
	JScrollPane scp = new JScrollPane(dbt);
	fp.add(scp);

	return fp;

    }

    private JPanel displayPanel() {

        JPanel fp = new JPanel();
	response = new JTextArea(12,40);
	response.setEditable(false);
	response.setFont(new Font("Monospaced", Font.PLAIN, 12));

	JScrollPane scrollpane = new JScrollPane(response);

	fp.add(scrollpane);

	return fp;


    }



    public SqlMonitor(String host, String user, String password, String database) {

	setHost(host);
	setUser(user);
	setPassword(password);
	setDatabase(database);
	tk = this.getToolkit();

	//dt = new JDBCAdapter(host, user,password,database);

	this.setLayout(new BorderLayout());
	FfAlignerLayoutPanel fp = new FfAlignerLayoutPanel();

	lowerPanel = new JPanel();
	lowerPanel.add(displayPanel());

	upperPanel = new JPanel();
	upperPanel.add(queryPanel());

	fp.setNumberOfRows(1);

	fp.addComponent(upperPanel);
	fp.addComponent(lowerPanel);
	this.add("North",menubar());
	this.add("South",toolbar());
	this.add("Center",fp);
	//fitSize();

	this.addComponentListener(new ComponentAdapter() {
	   public void componentHidden(ComponentEvent e) {}
	   public void componentMoved(ComponentEvent e) {}
	   public void componentResized(ComponentEvent e) { 
	       //fitSize();
	       upperPanel.updateUI();
	       lowerPanel.updateUI();
	   }
	});
	   

    }

    public void update() {  this.updateUI();}


    public void execQuery() {

	    /** if it is a query send it to the table, otherwise execute
	     *  the command and display the result of the command in the
	     *  message board
	     */
	    if ( query.getText().toLowerCase().startsWith("select") | query.getText().toLowerCase().startsWith("show") ) {
         	 st = new SqlPanel(getHost(),getUser(),getPassword(),getDatabase(),query.getText());   
		 scp = new JScrollPane(st.tableView);

		 //fitSize();
		 lowerPanel.removeAll();
		 lowerPanel.add(scp);
		 lowerPanel.updateUI();

	    } else {
               t_connect con = new t_connect(getHost(),getUser(),getPassword(),getDatabase());
	     if (con.getError() != null) {
                tk.beep();
             } else {
	     try
	       {
		  int records = con.stmt.executeUpdate(query.getText());
		  response.append(Integer.toString(records)+" rows affected\n");
		  con.close();
		  lowerPanel.removeAll();
		  lowerPanel.add(displayPanel());
		  lowerPanel.updateUI();
	       } catch (Exception excpt) {
		   tk.beep();
               } 
	     }
	    }
    }


    public void fitSize() {

		 
		 Dimension d = new Dimension();
		 d = this.getSize();
		 
		 Dimension q = new Dimension();
		 q = query.getPreferredSize();

		 Dimension r = new Dimension();
		 r = lowerPanel.getPreferredSize();

		    double dou;
		    dou = (d.height - tbDim.height) * 0.3;
		    Double doux = new Double(dou);
		    q.height = doux.intValue();
		    q.width  = d.width;
		    upperPanel.setSize(q);

		    
		    dou = (d.height - tbDim.height) * 0.7;
                    Double douy = new Double(dou);
		    r.height = douy.intValue();
		    r.width  = d.width;
		    lowerPanel.setSize(r);

    }
    


    public static void main(String args[]) {

	System.out.println("Fredy's SQL-Monitor\n" +
			   "-------------------- Version 2\n" +
                           "is a part of Admin and under GPL");
	if ( args.length != 4) {
	    System.out.println("Syntax: java SqlMonitor host user password database");
	    System.exit(0);
	}
	final JFrame f = new JFrame("SQL-Monitor");
	f.getContentPane().setLayout(new FlowLayout());
	final SqlMonitor g = new SqlMonitor(args[0], args[1], args[2], args[3]);
	f.getContentPane().add(g);
	f.pack();
	f.addWindowListener(new WindowAdapter() {
	    public void windowActivated(WindowEvent e) {}
	    public void windowClosed(WindowEvent e) {}
	    public void windowClosing(WindowEvent e) {System.exit(0);}
            public void windowDeactivated(WindowEvent e) {}
            public void windowDeiconified(WindowEvent e) {}
            public void windowIconified(WindowEvent e) {}
            public void windowOpened(WindowEvent e) {}});
	g.exit.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	f.addComponentListener(new ComponentAdapter() {
	   public void componentHidden(ComponentEvent e) {}
	   public void componentMoved(ComponentEvent e) {}
	   public void componentResized(ComponentEvent e) { 
	      g.fitSize();
	      g.upperPanel.updateUI();
	      g.lowerPanel.updateUI();
	   }
	});

        g.quit.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.exit(0);
		}});
	g.setTitle.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		final String t =  JOptionPane.showInputDialog(f,"Please enter title");
		if (t !=null ) f.setTitle(t);
		}});

	f.setVisible(true);
    }
}
      



